// StringEx.h: interface for the CStringEx class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_STRINGEX_H__5EAAE03C_9623_4544_80EF_F0D88C4EED05__INCLUDED_)
#define AFX_STRINGEX_H__5EAAE03C_9623_4544_80EF_F0D88C4EED05__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "math.h"

//////////////////////////////////////////////////////////////////////
// StringEx.h
//

class CStringEx : public CString
{
public:
	CStringEx() : CString( ){};
	CStringEx( const CString& stringSrc) : CString( stringSrc ){};
	CStringEx( const CStringEx& stringSrc) : CString( stringSrc ){};
	CStringEx( TCHAR ch, int nRepeat = 1 ) : CString( ch, nRepeat ){};
	CStringEx( LPCTSTR lpch, int nLength ) : CString( lpch, nLength ){};
	CStringEx( const unsigned char* psz ) : CString( psz ){};
	CStringEx( LPCWSTR lpsz ) : CString( lpsz ){};
	CStringEx( LPCSTR lpsz ) : CString( lpsz ){};

	CStringEx(const int i)				: CString(itoa(i))			{}
	CStringEx(const UINT u)				: CString(utoa(u))			{}
	CStringEx(const double d)				: CString(dtoa(d))			{}

	CStringEx& Insert(int pos, LPCTSTR s);
	CStringEx& Insert(int pos, TCHAR c);

	CStringEx& Delete(int pos, int len);
	CStringEx& Replace(int pos, int len, LPCTSTR s);

	int Find( TCHAR ch, int startpos = 0 ) const;
	int Find( LPCTSTR lpszSub, int startpos = 0 ) const;
	int FindNoCase( TCHAR ch, int startpos = 0 ) const;
	int FindNoCase( LPCTSTR lpszSub, int startpos = 0 ) const;

	int FindReplace( LPCTSTR lpszSub, LPCTSTR lpszReplaceWith, BOOL bGlobal = TRUE );
	int FindReplaceNoCase( LPCTSTR lpszSub, LPCTSTR lpszReplaceWith, 
				BOOL bGlobal = TRUE );

	int ReverseFind( TCHAR ch ) const{ return CString::ReverseFind(ch);};
	int ReverseFind( LPCTSTR lpszSub, int startpos = -1 ) const;
	int ReverseFindNoCase( TCHAR ch, int startpos = -1  ) const;
	int ReverseFindNoCase( LPCTSTR lpszSub, int startpos = -1 ) const;

	CStringEx GetField( LPCTSTR delim, int fieldnum);
	CStringEx GetField( TCHAR delim, int fieldnum);
	int GetFieldCount( LPCTSTR delim );
	int GetFieldCount( TCHAR delim );

	CStringEx GetDelimitedField( LPCTSTR delimStart, LPCTSTR delimEnd, 
				int fieldnum = 0);

	void GetWindowsDirectory();
	void GetSystemDirectory();
	void GetCurrentDirectory();
	void GetDateDirectory();
	void Fixate();
	void ProcessMacros(const char* szSrc);

protected:
	void ExpandMacro(char* pchMacroString);
	int GetMacroIndex(char* pchMacroString);
	void Concat(const char* pchString);
	void GetDateString(char* pchBuffer);

public:
	double	Double() const				{ return atof(m_pchData); }
	int		Int() const					{ return atoi(m_pchData); }
	char	Char() const				{ return m_pchData[0]; }
	bool	Bool() const				{ return (Int() != 0); }

	friend	CStringEx itoa(int i);
	friend	CStringEx utoa(UINT u);
	friend	CStringEx dtoa(double d);
	friend	CStringEx dtoa(double d, int n);
};

#endif // !defined(AFX_STRINGEX_H__5EAAE03C_9623_4544_80EF_F0D88C4EED05__INCLUDED_)
